<template>
  <el-select
    v-model="selected"
    class="teach-class-select"
    :placeholder="placeholder"
    filterable
    :clearable="clearable"
    :disabled="disabled"
    @change="select"
  >
    <el-option
      v-for="item in optionList"
      :key="item.id"
      :value="item.id"
      :label="item.name"
    >
    </el-option>
  </el-select>
</template>

<script>
import { commonTeachClazzQuery } from "../../modules/client/api";

export default {
  name: "teach-class-select",
  props: {
    disabled: { type: Boolean, default: false },
    placeholder: { type: String, default: "请选择" },
    value: { type: [Number, String], default: "" },
    clearable: { type: Boolean, default: true },
    filterData: {
      type: Object,
      default() {
        return {
          paperArchivesId: "",
          courseName: ""
        };
      }
    }
  },
  data() {
    return {
      optionList: [],
      selected: ""
    };
  },
  watch: {
    value: {
      immediate: true,
      handler(val) {
        this.selected = val;
      }
    },
    "filterData.courseName": {
      handler(val, oldval) {
        console.log(val);
        if (val !== oldval) {
          this.search();
          this.$emit("input", "");
          this.$emit("change", {});
        }
      }
    }
  },
  created() {
    this.search();
  },
  methods: {
    async search() {
      this.optionList = [];
      if (!this.filterData.courseName) return;
      const res = await commonTeachClazzQuery({
        ...this.filterData
      });
      this.optionList = res;
    },
    select() {
      this.$emit("input", this.selected);
      this.$emit(
        "change",
        this.optionList.find(item => item.id === this.selected)
      );
    }
  }
};
</script>
